(** Déclaration de variables *)

let basis = ref Basis.nil;;

let newvar s = 
  let (x,b) = Basis.add (!basis) s in
  basis := b ;
    (Support.varToProgVar x);;

module VB =
struct

let x = newvar "x";;
let q = newvar "q";;
let r = newvar "r";;
let a = newvar "a";;

end;;
open VB;;

(** Execution des tests **)

open DemoPLVerifier;;

let tests = ref 0 ;;
let failed = ref 0;;

let incr r = r:=!r+1;;

let afficheok attendu =
  if attendu then
    print_string " passed as expected\n"
  else
    print_string " failed as expected\n";;

let afficheko attendu =
  incr failed;  
  if attendu then
    print_string "ko (passed vs failed expected)\n"
  else
    print_string "ko (failed vs passed expected)\n";;

let launch nom test attendu =
try
  Printf.printf "*** %s: " nom;
  if (hoareTripleVerifier test)=attendu 
  then
     afficheok attendu
  else
     afficheko attendu
with Failure(s) -> 
  Printf.printf " failure %s !\n" s ;
  if attendu 
  then afficheko true
  else afficheok false;;

let rec launch_list l attendu = 
    match l with
      | [] -> print_newline();
      | (nom,test)::ll -> 
	incr tests;
	launch (CoqPr.charListTr nom) test attendu;
	launch_list ll attendu;;
 
module Ex = DemoPLTests.Examples(VB);;

launch_list Ex.tests_ok true;;
launch_list Ex.tests_ko false;;

let nbfails = !failed in
if nbfails=0 then
  Printf.printf "*** Passed %d tests\n" !tests
else (
  Printf.printf "*** %d failure(s) in %d tests:\n" nbfails !tests;
  exit 1);;
