let c str = CoqPr.stringTr str

(* CoqAddOn.sprintf *)
let sprintfTs: T.testT
=	let chk (nm, s, l, r): T.stateT -> T.stateT
	= fun st ->
		let s' = CoqAddOn.sprintf s l in
		if r = s'
		then T.succeed st
		else
			let e = CoqPr.charListTr s' in
			T.fail nm e st
	in
	let tcs: (string * char list * char list list * char list) list
	= [
	"empty", c "", [], c "";
	"plain0", c "hi", [], c "hi";
	"spec0", c "hi %s", [c "you"], c "hi you";
	"spec1", c "hi %s!", [c "you"], c "hi you!";
	"spec2", c "hi %s, %s?", [c "there"; c "you"], c "hi there, you?";
	"spec3", c "%s", [c "blah"], c "blah";
	"percent0", c "10%%", [], c "10%";
	"esc0", c "\\n", [], c "\n"
	] in
	T.suite "sprintf" (List.map chk tcs)

let ts: T.testT
= T.suite "CoqAddOn" [sprintfTs]
